﻿using BPA.Message;
using BPASmartClient.Business;
using BPASmartClient.CustomResource.UserControls;
using BPASmartClient.CustomResource.UserControls.MessageShow;
using BPASmartClient.Device;
using BPASmartClient.EventBus;
using BPASmartClient.Helper;
using BPASmartClient.Message;
using BPASmartClient.Model;
using BPASmartClient.Model.冰淇淋.Enum;
using BPASmartClient.Model.咖啡机.Enum;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace BPASmartClient
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            Initialize();
        }

        #region 私有
        /// <summary>
        /// 初始化
        /// </summary>
        private void Initialize()
        {
            this.ButClose.Click += (o, e) => { this.Close(); };
            this.br.MouseLeftButtonDown += (o, e) =>
            {
                if (e.ClickCount > 1)
                {
                    if (this.WindowState == WindowState.Maximized)
                        this.WindowState = WindowState.Normal;
                    else if (this.WindowState == WindowState.Normal)
                        this.WindowState = WindowState.Maximized;
                }
                this.DragMove();
            };
            MenuItem_Click(new MenuItem() { Tag = "LogView", Header = "日志监视" }, null);

            ThreadManage.GetInstance().Start(new Action(() =>
            {
                new MainConsole().Start();
            }), "启动主控制台");
        }
        #endregion

        #region Click
        /// <summary>
        /// 菜单切换栏
        /// </summary>
        private void MenuItem_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                if (sender is MenuItem)
                {
                    Type type = Type.GetType($"BPASmartClient.Control.{(sender as MenuItem).Tag?.ToString()}");
                    if (type == null) { MenuClick((sender as MenuItem).Tag?.ToString()); return; }
                    ConstructorInfo cti = type.GetConstructor(System.Type.EmptyTypes);
                    contentRegion.Content = (FrameworkElement)cti.Invoke(null);
                    Title.Text = (sender as MenuItem).Header?.ToString() + "界面";
                }
            }
            catch (Exception ex)
            {
                MessageLog.GetInstance.ShowEx($"BPASmartClient 中引发错误,MainWindow.xaml.cs 类MenuItem_Click(),描述：[{ex.Message}]");
            }
        }
        #endregion

        #region 公用
        /// <summary>
        /// 菜单点击
        /// </summary>
        /// <param name="name"></param>
        public void MenuClick(string name)
        {
            try
            {
                switch (name)
                {
                    case "Close":
                        this.Close();
                        break;
                    case "IOT":
                        BrowserHelper.OpenDefaultBrowserUrl("http://iot.black-pa.com");
                        break;
                }
            }
            catch (Exception ex)
            {
                MessageLog.GetInstance.ShowEx($"BPASmartClient 中引发错误,MainWindow.xaml.cs 类MenuClick(),描述：[{ex.Message}]");
            }
        }
        #endregion


        #region 临时测试代码
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            //new Demo_MakeCoffeeEvent() { Id = 1 }.Publish();
            //new DRCoffee_MakeCoffeeEvent() { Id = 1, DrinkCode= DrCoffeeDrinksCode.两杯意式浓缩 }.Publish();
            //new DRCoffee_CoffeeCommCmdEvent() { Id = 1,CommCmd = DrCoffeeCommCmd.冲煮系统快速冲洗指令}.Publish();

            MorkOrderPush morkOrderPush = new MorkOrderPush() { DeviceId = 2 };
            var temp = BPAPackage.Make(morkOrderPush, 12, BPA.Message.Enum.DeviceClientType.MORKS);
            Plugin.GetInstance().GetPlugin<MQTTMgr>().Publish("DOWN/MORKS/ORDER/12", temp.Serialize());
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {

            //List<string> name = new List<string>();
            //var a = AppDomain.CurrentDomain.GetAssemblies();
            //foreach (var item in a)
            //{
            //    if (item.FullName.Contains("Mork"))
            //    {
            //        name.Add(item.FullName);
            //    }
            //}

            //var re = this.GetType().Assembly.GetTypes().ToList().Where(p => p.GetInterfaces().Contains(typeof(IDevice))).ToList();
            //var res = AppDomain.CurrentDomain.GetAssemblies();
            //var re = 

            NoticeDemoViewModel.OpenMsg(EnumPromptType.Info, this, "我是标题", "我是消息内容!我是消息内容!我是消息内容!我是消息内容!");
            NoticeDemoViewModel.OpenMsg(EnumPromptType.Error, this, "我是标题", "我是消息内容!我是消息内容!我是消息内容!我是消息内容!");
            NoticeDemoViewModel.OpenMsg(EnumPromptType.Warn, this, "我是标题", "我是消息内容!我是消息内容!我是消息内容!我是消息内容!");
            NoticeDemoViewModel.OpenMsg(EnumPromptType.Success, this, "我是标题", "我是消息内容!我是消息内容!我是消息内容!我是消息内容!");
        }
        #endregion


    }
}
